package Upftp2;
use strict;
######################################################################
# Upftp.pl : Abv[hpFTPNCAg CW[
######################################################################
my $Version = '1.12';

use File::Find;			# t@Č

use DateList;			# ŏIXVXg
use DirList;			# fBNgXg
use Ftp;			# FTP]

sub new{
	my $this = shift;

	use Getopt::Std;		# R}hCIvV
	my %options;
	getopts('p:c:t:anf',\%options);
	if ($options{p}){				# -p: pX[hÍ
		use Password;
		my $pass = new Password->EnCrypt($options{p});
		print "CryptPass\t$pass\n";
		exit;
	}
	if ($options{t}){				# -u: t@CXg
		open IN,$options{t} or die "$options{t}܂";
		foreach (@ARGV = <IN>){	chomp;}
		close IN;
	}

	# Ȃgp
	Usage() if ($#ARGV == -1 && !$options{a});

	my $dir = $options{c} || 'config';		# -c: configfBNg
	bless {
		DirList => new DirList($dir.'/dirlist.txt'),
		DateList => new DateList($dir.'/date.dat'),
		Ftp => new Ftp($dir.'/serverlist.txt'),
		AllTransMode => $options{a},		# -a: S][h
		NonTransMode => $options{n},		# -n: ][h
		ForceTransMode => $options{f}		# -f: ][h
	} , $this;
}

sub main{
	my $this = shift;

	if ($this->{AllTransMode}){
		# S]
		foreach my $dirlist (@{$this->{DirList}->get}){
			find(	sub{ $this->UpFile($dirlist,$File::Find::name) if -f; },
				$dirlist->{LocalDir} );
		}
	}else{
		# Ώۃt@C
		my @files = map{ glob($_) } @ARGV;	# ChJ[hWJ
		$this->SearchFile(@files);
	}

	$this->{Ftp}->Close();			# ڑ

}
# t@CT
sub SearchFile{
	my $this = shift;
	my @files = @_;
	foreach my $file (@files){
		$file =~ tr|\\|/|;	# \  / ɒu
		$file =~ s|/$||;	# Ō/
	}

	foreach my $dirlist (@{$this->{DirList}->get}){
		foreach my $file (@files){
			my $dir = $file;
			($dirlist->{LocalDir} =~ /^$dir/i)
				? ($dir = $dirlist->{LocalDir})
				: ($dir =~ /^$dirlist->{LocalDir}/i)
					or next;

			find(	sub{ $this->UpFile($dirlist,$File::Find::name) if -f; },
				$dir );
		}
	}
}

# t@C]
sub UpFile{
	my $this = shift;
	my ($dirlist,$file) = @_;
	my ($path) = $file =~ /^$dirlist->{LocalDir}(.*\/)/i;
	$path =~ s|^/||;

	$file = lc($file);				# t@C
	my $key = "$dirlist->{Name}-".$file;		# nbṼL[
	unless ($this->{NonTransMode}){
		unless ($this->{ForceTransMode}){
			# ŏIXVɓ]߂
			return if ($this->{DateList}->get($key) > (stat $file)[9]);
		}

		# ʉ߃tB^
		my $is_pass = 0;
		foreach my $filter (@{$dirlist->{PassFilter}}){
			$is_pass = 1 if ($file =~ m|$filter|i);
		}
		return if ($#{$dirlist->{PassFilter}} >= 0 && $is_pass == 0);

		# tB^
		foreach my $filter (@{$dirlist->{LimitFilter}}){
			return if ($file =~ m|$filter|i);
		}

		$this->{Ftp}->Open($dirlist->{Server});			# ڑ
		$this->{Ftp}->Cwd($dirlist->{RemoteDir} . $path);	# fBNgړ
		$this->{Ftp}->Put($file);				# t@CAbv[h
	}

	$this->{DateList}->set($key,time);		# XV̍XV
}

# g
sub Usage{
	print<<EOT;
upftp2.pl - Ver.$Version
  upftp2.pl [-c directory][-t filename][-a][-n][-f] [filename...]
  upftp2.pl [-p password]

ɗ^ꂽt@C(΃pX)Abv[h܂B
	-c	configfBNgw肵܂(ftHgłconfig)
	-t	̑ɃeLXgt@Ct@CXgǂݍ݂܂B
	-a	̑ɐݒ肳ꂽSẴt@C]܂B
	-n	ۂFTP]ɁAdate.dat݂̂XV܂B
	-f	ŏIXVɊւ炸AIFTP]܂B
	-p	pX[hÍ܂B
EOT
	exit;
}

1;
